//+------------------------------------------------------------------+
//|                                                marketprofile.mq4 |
//|                            Copyright  2006, Viatcheslav Suvorov | 
//+------------------------------------------------------------------+
//|                                         Modified by TwoBuckChuck |
//+------------------------------------------------------------------+
#property copyright "Viatcheslav Suvorov"

#property indicator_chart_window

extern datetime StartDate         = D'17.01.2007 10:00';
extern bool     ShowToday         = false;
extern int      CountProfile      = 5;
extern bool     SkipSundayData    = true;
extern color    Asia_Color        = Blue;
extern color    Europe_Color      = Blue;
extern color    US_Color          = Blue;
extern color    POC_Color         = White;
extern double   POC_Height        = 1.0;
extern int      POCLeftOffset     = 0;
extern int      POCRightOffset    = 500;
extern int      US_Start_Hour     = 13;
extern int      EU_Start_Hour     = 8;
extern bool     DrawProfiles      = false;
extern bool     ShowPOCText       = true;
extern int      POCTextSize       = 8;
extern int      POCTextPosition   = 1; //0 left, 1 right
extern int      POCTextSecsOffset = 35000;
extern bool     UseShortDays      = true;

int fontsize=10;
int i,j;
double LastHigh,LastLow,CurPos;
bool signal;
datetime flag;
string Obj_Prefix;
string Days[7] = {"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"};
string DaysShort[7] = {"Sun", "Mon", "Tues", "Wed", "Thurs", "Fri", "Sat"};
string UseDays[7];
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   DeleteObjects(); //only delete our objects
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   string short_name;
   
   if (UseShortDays) ArrayCopy(UseDays, DaysShort);
   else ArrayCopy(UseDays, Days);
   
   Obj_Prefix = "mp__"; //object prefix
   
   //---- name for DataWindow and indicator subwindow label
   short_name="MarketProfile";
   IndicatorShortName(short_name);
   SetIndexLabel(0, short_name);
   
   POCRightOffset *= -1;
   if (POCRightOffset >= POCLeftOffset) POCRightOffset = 0;
   
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   if (flag!=Time[0]) // Calculate on new bar.
   { 
      flag=Time[0];
      deinit();
      double onetick, poc_h;  
      double Mediana=0;
      int MaxSize=0;
      int MySize=0;
      int MySizeEuropa=0;
      int MySizeAzia=0;
      int MySizeAmerica=0;
      int BACK=0;
      
      if (ShowToday) StartDate = Time[0];
      if (StartDate == D'17.01.2007 10:00') StartDate=iTime(NULL, PERIOD_D1, 1);
      
      while (TimeDayOfWeek(StartDate)==0 && SkipSundayData)
      {
         StartDate=iTime(NULL, PERIOD_D1, iBarShift(NULL,PERIOD_D1,StartDate)+1);
      }
      int x=Period();
      if (x>60) return(-1);
      if (x<5) return(-1);

      BACK=0;
      while (TimeDayOfYear(Time[BACK])>TimeDayOfYear(StartDate) || TimeYear(Time[BACK])!=TimeYear(StartDate) && (BACK<Bars))
      {  
         BACK++;   
         if (BACK>=Bars) return(0);
      }//while

      onetick = 1/(MathPow(10,Digits));
      poc_h = onetick;
      if (Digits == 3 || Digits == 5) poc_h *= (POC_Height*10);
      else poc_h *= POC_Height;
      i=BACK;
      int cycles;

      for (cycles=CountProfile;cycles>0;cycles--)
      {
         signal=false;
         LastHigh=High[i];
         LastLow=Low[i]; 
         
         while (!signal)
         {
            if (High[i+1]>LastHigh) LastHigh=High[i+1];
            if (Low[i+1]<LastLow) LastLow=Low[i+1];
            MaxSize=0;
            MySize=0;

            if (TimeDay(Time[i])!=TimeDay(Time[i+1]) && (!SkipSundayData || (TimeDayOfWeek(Time[i]) != 0 && SkipSundayData)))
            {
               signal=true;
               CurPos=LastLow;
               
               while (CurPos<=LastHigh)
               {
                  MySizeAzia=0;
                  MySizeEuropa=0;
                  MySizeAmerica=0;
                  
                  for (j=i;j>=BACK;j--)
                  {
                     if ((High[j]>=CurPos) && (Low[j]<=CurPos))
                     {
                        MySize++;       
                        if (TimeHour(Time[j])>=US_Start_Hour)  MySizeAmerica++;
                        else if ((TimeHour(Time[j])>=EU_Start_Hour) && (TimeHour(Time[j])<US_Start_Hour)) MySizeEuropa++; 
                        else MySizeAzia++; 
                     }//if  
                     
                  }//for
                  
                  if (MySizeAzia+MySizeEuropa+MySizeAmerica>MaxSize)
                  {
                     MaxSize=MySizeAzia+MySizeEuropa+MySizeAmerica;
                     Mediana=CurPos;
                  }
                  
                  if (i-MySizeAzia>=0 && DrawProfiles)
                  {
                     if(ObjectFind(Obj_Prefix+"rec"+"Azia"+TimeToStr(Time[i],TIME_DATE)+CurPos) == -1 && MySizeAzia!=0)
                     {
                        ObjectCreate(Obj_Prefix+"rec"+"Azia"+TimeToStr(Time[i],TIME_DATE)+CurPos, OBJ_RECTANGLE, 0, Time[i], CurPos,Time[i-MySizeAzia],CurPos+onetick);           
                        ObjectSet(Obj_Prefix+"rec"+"Azia"+TimeToStr(Time[i],TIME_DATE)+CurPos, OBJPROP_COLOR, Asia_Color);
                     }//if      
                     
                     if(ObjectFind(Obj_Prefix+"rec"+"Europa"+TimeToStr(Time[i],TIME_DATE)+CurPos) == -1 && MySizeEuropa!=0)
                     {
                        ObjectCreate(Obj_Prefix+"rec"+"Europa"+TimeToStr(Time[i],TIME_DATE)+CurPos, OBJ_RECTANGLE, 0, Time[i-MySizeAzia], CurPos,Time[i-MySizeAzia-MySizeEuropa],CurPos+onetick);
                        ObjectSet(Obj_Prefix+"rec"+"Europa"+TimeToStr(Time[i],TIME_DATE)+CurPos, OBJPROP_COLOR, Europe_Color);           
                     }//if  
                      
                     if(ObjectFind(Obj_Prefix+"rec"+"America"+TimeToStr(Time[i],TIME_DATE)+CurPos) == -1 && MySizeAmerica!=0)
                     {
                        ObjectCreate(Obj_Prefix+"rec"+"America"+TimeToStr(Time[i],TIME_DATE)+CurPos, OBJ_RECTANGLE, 0, Time[i-MySizeAzia-MySizeEuropa], CurPos,Time[i-MySizeAzia-MySizeEuropa-MySizeAmerica],CurPos+onetick);
                        ObjectSet(Obj_Prefix+"rec"+"America"+TimeToStr(Time[i],TIME_DATE)+CurPos, OBJPROP_COLOR, US_Color);                      
                     }//if      
                  }
                  CurPos=CurPos+onetick;
               
               }//while
               
               int ti = i+POCRightOffset,
                   ti2 = i+POCLeftOffset;
               if (ti < 0) ti = 0; 
               if (ti2 < 0) ti2 = 0;
               
               ObjectCreate(Obj_Prefix+"mediana"+TimeToStr(Time[i],TIME_DATE), OBJ_RECTANGLE, 0, Time[ti], Mediana,Time[ti2],Mediana+poc_h);
               ObjectSet(Obj_Prefix+"mediana"+TimeToStr(Time[i],TIME_DATE), OBJPROP_STYLE, STYLE_SOLID);
               ObjectSet(Obj_Prefix+"mediana"+TimeToStr(Time[i],TIME_DATE), OBJPROP_COLOR, POC_Color);
               
               if (ShowPOCText)
               {
                  int ti3, toff;
                  if (POCTextPosition == 0)
                  {
                     ti3 = ti2;
                     toff = POCTextSecsOffset*(-1);
                  }
                  else 
                  {
                     ti3 = ti;
                     toff = MathAbs(POCTextSecsOffset);
                  }
                  ObjectCreate(Obj_Prefix+TimeToStr(Time[i],TIME_DATE), OBJ_TEXT, 0, Time[ti3]+toff, Mediana-poc_h);
                  ObjectSetText(Obj_Prefix+TimeToStr(Time[i],TIME_DATE), TimeToStr(Time[i], TIME_DATE)+" - "+UseDays[TimeDayOfWeek(Time[i])]+" - "+DoubleToStr(Mediana, Digits), POCTextSize, "Arial", POC_Color);
               }
                
               BACK=i+1; 
                 
            }//if
            
            i++;   
            if (i>=Bars) return(0);
            
         } //while
         
      } //for
      
   } //if
   
   return(0);
}

//+------------------------------------------------------------------+
//| Delete only our objects                                          |
//+------------------------------------------------------------------+
int DeleteObjects()
{     
   for (int i = ObjectsTotal() - 1; i >= 0; i--)
   {
       string label = ObjectName(i);
       if (StringSubstr(label, 0, StringLen(Obj_Prefix)) != Obj_Prefix)
           continue;
       ObjectDelete(label);   
   }
   return(0);
}
//+------------------------------------------------------------------+